# <img src="icon.png" width="30"> Harmony Player

A next-gen music player built with Electron.

![Harmony](screenshot.png?raw=true "Harmony")

* Play tracks from SoundCloud, Google Play Music, Spotify or your local tracks
* Sound menu integration
* Last.fm scrobbling
* Super sleek interface
* Keyboard control
* Distraction-free
* Background notifications


## Google Play Music 2 Factors auth

If you want to use Harmony with your Google account using 2-factors authentification (altough insecure and at your own risk) enable the insecure app access in [your Google account settings](https://myaccount.google.com/security?pli=1#connectedapps).

## Installation

You can download compiled versions of Harmony for Windows, Mac OS, and Linux (.deb) from [the website](http://getharmony.xyz).

**Mac OS (OSX):**

Unzip, and move the .app to the /Applications directory.

**Windows:**

Run and install

**Linux:**

Use `sudo dpkg -i ` followed by the .deb file to install.


## Controls

**Space** -> Play/Pause

**N or Ctrl/Cmd + Right** -> Next track

**P or Ctrl/Cmd + Left** -> Prev track

**L** -> Like track

**Ctrl/Cmd + F** -> Search

## Development environment

To get a local development copy running, you will need:

- [npm][], usually installed with [node][]
- [git][], version control tool

[git]: http://git-scm.com/
[npm]: http://npmjs.org/
[node]: http://nodejs.org/

Follow the steps below to get a development copy set up:

```bash
# Clone our repository
git clone https://github.com/vincelwt/harmony.git
cd harmony/

# Install our dependencies and dev dependencies
npm install

# Start up
npm start
```

After running the above steps, a copy of Harmony should begin running.

You can check out the Trello board [here](https://trello.com/b/nlPjOCTO/harmony-todo).


## Contribute

If you enjoyed using Harmony, and/or would like to support the development, please consider making a donation.

[![Donate](https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif)](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=XLQTUNFTN9FU8)
